Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxrandr.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxrandr.h
@@ -0,0 +1,38 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXRANDR_H
+#define DMXRANDR_H
+
+#include "dmxscrinit.h"
+#include "randrstr.h"
+
+extern Bool dmxRRScreenInit (ScreenPtr pScreen);
+extern Bool dmxScreenEventCheckRR (ScreenPtr           pScreen,
+				   xcb_generic_event_t *event);
+extern Bool dmxBERRScreenInit (ScreenPtr pScreen);
+extern void dmxBERRScreenFini (ScreenPtr pScreen);
+
+#endif /* DMXRANDR_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxscrinit.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.c
@@ -40,8 +40,8 @@
 #endif
 
 #include "dmx.h"
+#include "dmxextension.h"
 #include "dmxsync.h"
-#include "dmxshadow.h"
 #include "dmxscrinit.h"
 #include "dmxcursor.h"
 #include "dmxgc.h"
@@ -52,14 +52,41 @@
 #include "dmxcmap.h"
 #include "dmxprop.h"
 #include "dmxdpms.h"
+#include "dmxlog.h"
+#include "dmxcb.h"
+#include "dmxinit.h"
+#include "dmxgrab.h"
+#include "dmxselection.h"
+#include "dmxatom.h"
+#include "dmxshm.h"
+#include "dmxdnd.h"
+#include "dmxlaunch.h"
+
+#ifdef PANORAMIX
+#include "panoramiX.h"
+#include "panoramiXsrv.h"
+#endif
 
 #ifdef RENDER
 #include "dmxpict.h"
 #endif
 
+#ifdef COMPOSITE
+#include "dmxcomp.h"
+#endif
+
+#ifdef RANDR
+#include "dmxrandr.h"
+#endif
+
+#ifdef XV
+#include "dmxxv.h"
+#endif
+
 #include "fb.h"
 #include "mipointer.h"
 #include "micmap.h"
+#include "mivalidate.h"
 
 extern Bool dmxCloseScreen(int idx, ScreenPtr pScreen);
 static Bool dmxSaveScreen(ScreenPtr pScreen, int what);
@@ -73,20 +100,20 @@ DevPrivateKey dmxPixPrivateKey = &dmxPix
 int dmxFontPrivateIndex;        /**< Private index for Fonts     */
 DevPrivateKey dmxScreenPrivateKey = &dmxScreenPrivateKey; /**< Private index for Screens   */
 DevPrivateKey dmxColormapPrivateKey = &dmxColormapPrivateKey; /**< Private index for Colormaps */
+DevPrivateKey dmxDevicePrivateKey = &dmxDevicePrivateKey; /**< Private index for Devices */
 #ifdef RENDER
 DevPrivateKey dmxPictPrivateKey = &dmxPictPrivateKey; /**< Private index for Picts     */
 DevPrivateKey dmxGlyphSetPrivateKey = &dmxGlyphSetPrivateKey; /**< Private index for GlyphSets */
+DevPrivateKey dmxGlyphPrivateKey = &dmxGlyphPrivateKey; /**< Private index for Glyphs */
 #endif
 
 /** Initialize the parts of screen \a idx that require access to the
  *  back-end server. */
-void dmxBEScreenInit(int idx, ScreenPtr pScreen)
+void dmxBEScreenInit(ScreenPtr pScreen)
 {
-    DMXScreenInfo        *dmxScreen = &dmxScreens[idx];
-    XSetWindowAttributes  attribs;
-    XGCValues             gcvals;
-    unsigned long         mask;
-    int                   i, j;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+    char          buf[256];
+    int           major, minor, i, j;
 
     /* FIXME: The dmxScreenInit() code currently assumes that it will
      * not be called if the Xdmx server is started with this screen
@@ -105,99 +132,876 @@ void dmxBEScreenInit(int idx, ScreenPtr
     pScreen->whitePixel = dmxScreen->beWhitePixel;
     pScreen->blackPixel = dmxScreen->beBlackPixel;
 
-    /* Handle screen savers and DPMS on the backend */
-    dmxDPMSInit(dmxScreen);
+    dmxScreen->selectionOwner = None;
 
-    /* Create root window for screen */
-    mask = CWBackPixel | CWEventMask | CWColormap | CWOverrideRedirect;
-    attribs.background_pixel = dmxScreen->beBlackPixel;
-    attribs.event_mask = (KeyPressMask
-                          | KeyReleaseMask
-                          | ButtonPressMask
-                          | ButtonReleaseMask
-                          | EnterWindowMask
-                          | LeaveWindowMask
-                          | PointerMotionMask
-                          | KeymapStateMask
-                          | FocusChangeMask);
-    attribs.colormap = dmxScreen->beDefColormaps[dmxScreen->beDefVisualIndex];
-    attribs.override_redirect = True;
+    sprintf(buf, "DMX_%s", dmxDigest);
+
+    /* prefetch all valid atoms */
+    for (i = 1; ValidAtom ((Atom) i); i++);
+    while (--i)
+	dmxBEPrefetchAtom (dmxScreen, (Atom) i);
     
-    dmxScreen->scrnWin =
-	XCreateWindow(dmxScreen->beDisplay, 
-		      DefaultRootWindow(dmxScreen->beDisplay),
-		      dmxScreen->scrnX,
-		      dmxScreen->scrnY,
-		      dmxScreen->scrnWidth,
-		      dmxScreen->scrnHeight,
-		      0,
-		      pScreen->rootDepth,
-		      InputOutput,
-		      dmxScreen->beVisuals[dmxScreen->beDefVisualIndex].visual,
-		      mask,
-		      &attribs);
-    dmxPropertyWindow(dmxScreen);
+    XLIB_PROLOGUE (dmxScreen);
+    dmxScreen->beSelectionAtom = XInternAtom (dmxScreen->beDisplay, buf, 0);
+    XLIB_EPILOGUE (dmxScreen);
 
-    /*
-     * This turns off the cursor by defining a cursor with no visible
-     * components.
-     */
+    /* Handle screen savers and DPMS on the backend */
+    dmxBEDPMSScreenInit (pScreen);
+
+#ifdef MITSHM
+    dmxBEShmScreenInit (pScreen);
+#endif
+
+#ifdef RANDR
+    dmxBERRScreenInit (pScreen);
+#endif
+
+#ifdef XV
+    dmxBEXvScreenInit (pScreen);
+#endif
+
+    major = XkbMajorVersion;
+    minor = XkbMinorVersion;
+    if (!XkbLibraryVersion (&major, &minor))
+    {
+	ErrorF ("Warning! X library built with XKB version %d.%02d\n",
+		major, minor);
+	ErrorF ("         but server was built with %d.%02d\n",
+		XkbMajorVersion, XkbMinorVersion);
+	ErrorF ("         Trying anyway, but XkbLibraryVersion\n");
+	ErrorF ("         reports incompatibilities\n");
+    }
+
+    dmxScreen->beXkb = XkbQueryExtension (dmxScreen->beDisplay, &i,
+					  &dmxScreen->beXkbEventBase,
+					  &minor, &i, &i);
+    if (dmxScreen->beXkb)
+	dmxLogOutput (dmxScreen, "Using XKB extension\n");
+
+    /* Create default drawables (used during GC creation) */
+    for (i = 0; i < dmxScreen->beNumPixmapFormats; i++) 
+	for (j = 0; j < dmxScreen->beNumDepths; j++)
+	    if ((dmxScreen->bePixmapFormats[i].depth == 1) ||
+		(dmxScreen->bePixmapFormats[i].depth ==
+		 dmxScreen->beDepths[j])) {
+		XLIB_PROLOGUE (dmxScreen);
+		dmxScreen->scrnDefDrawables[i] = (Drawable)
+		    XCreatePixmap(dmxScreen->beDisplay, dmxScreen->scrnWin,
+				  1, 1, dmxScreen->bePixmapFormats[i].depth);
+		XLIB_EPILOGUE (dmxScreen);
+		break;
+	    }
+}
+
+static void
+dmxSetWindowPixmap (WindowPtr pWin, PixmapPtr pPixmap)
+{
+    ScreenPtr       pScreen = pWin->drawable.pScreen;
+    DMXScreenInfo  *dmxScreen = &dmxScreens[pScreen->myNum];
+    PixmapPtr       pOld = (*pScreen->GetWindowPixmap) (pWin);
+
+    if (pPixmap != pOld)
+    {
+	dmxWinPrivPtr pWinPriv = DMX_GET_WINDOW_PRIV (pWin);
+
+	if (pPixmap && (*pScreen->GetWindowPixmap) (pWin->parent) != pPixmap)
+	    pWinPriv->redirected = TRUE;
+	else
+	    pWinPriv->redirected = FALSE;
+    }
+
+    DMX_UNWRAP(SetWindowPixmap, dmxScreen, pScreen);
+    if (pScreen->SetWindowPixmap)
+	(*pScreen->SetWindowPixmap) (pWin, pPixmap);
+    DMX_WRAP(SetWindowPixmap, dmxSetWindowPixmap, dmxScreen, pScreen);
+}
+
+static Bool
+dmxScreenEventCheckInput (ScreenPtr           pScreen,
+			  xcb_generic_event_t *event)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    return dmxInputEventCheck (&dmxScreen->input, event);
+}
+
+static void
+dmxScreenGetSelectionOwner (ScreenPtr pScreen)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    dmxScreen->selectionOwner = None;
+    while (dmxScreen->selectionOwner == None)
     {
-	char noCursorData[] = {0, 0, 0, 0,
-			       0, 0, 0, 0};
-	Pixmap pixmap;
-	XColor color, tmp;
-
-	pixmap = XCreateBitmapFromData(dmxScreen->beDisplay, dmxScreen->scrnWin,
-				       noCursorData, 8, 8);
-	XAllocNamedColor(dmxScreen->beDisplay, dmxScreen->beDefColormaps[0],
-			 "black", &color, &tmp);
-	dmxScreen->noCursor = XCreatePixmapCursor(dmxScreen->beDisplay,
-						  pixmap, pixmap,
-						  &color, &color, 0, 0);
-	XDefineCursor(dmxScreen->beDisplay, dmxScreen->scrnWin,
-		      dmxScreen->noCursor);
-
-	XFreePixmap(dmxScreen->beDisplay, pixmap);
-    }
-
-    XMapWindow(dmxScreen->beDisplay, dmxScreen->scrnWin);
-
-    if (dmxShadowFB) {
-	mask = (GCFunction
-		| GCPlaneMask
-		| GCClipMask);
-	gcvals.function = GXcopy;
-	gcvals.plane_mask = AllPlanes;
-	gcvals.clip_mask = None;
-
-	dmxScreen->shadowGC = XCreateGC(dmxScreen->beDisplay,
-					dmxScreen->scrnWin,
-					mask, &gcvals);
-
-	dmxScreen->shadowFBImage =
-	    XCreateImage(dmxScreen->beDisplay,
-			 dmxScreen->beVisuals[dmxScreen->beDefVisualIndex].visual,
-			 dmxScreen->beDepth,
-			 ZPixmap,
-			 0,
-			 (char *)dmxScreen->shadow,
-			 dmxScreen->scrnWidth, dmxScreen->scrnHeight,
-			 dmxScreen->beBPP,
-			 PixmapBytePad(dmxScreen->scrnWidth,
-				       dmxScreen->beBPP));
-    } else {
-	/* Create default drawables (used during GC creation) */
-	for (i = 0; i < dmxScreen->beNumPixmapFormats; i++) 
-	    for (j = 0; j < dmxScreen->beNumDepths; j++)
-		if ((dmxScreen->bePixmapFormats[i].depth == 1) ||
-		    (dmxScreen->bePixmapFormats[i].depth ==
-		     dmxScreen->beDepths[j])) {
-		    dmxScreen->scrnDefDrawables[i] = (Drawable)
-			XCreatePixmap(dmxScreen->beDisplay, dmxScreen->scrnWin,
-				      1, 1, dmxScreen->bePixmapFormats[i].depth);
-		    break;
+	xcb_connection_t                *c = dmxScreen->connection;
+	xcb_atom_t                      a = dmxScreen->beSelectionAtom;
+	xcb_get_selection_owner_reply_t *reply;
+
+	reply = xcb_get_selection_owner_reply (c,
+					       xcb_get_selection_owner (c, a),
+					       NULL);
+	if (!reply)
+	    break;
+
+	if (reply->owner)
+	{
+	    if (reply->owner != dmxScreen->rootWin)
+	    {
+		const uint32_t      value = XCB_EVENT_MASK_STRUCTURE_NOTIFY;
+		xcb_void_cookie_t   r;
+		xcb_generic_error_t *error;
+		
+		r = xcb_change_window_attributes_checked (c,
+							  reply->owner,
+							  XCB_CW_EVENT_MASK,
+							  &value);
+		error = xcb_request_check (c, r);
+		if (error)
+		{
+		    if (error->error_code != BadWindow)
+			dmxScreen->selectionOwner = reply->owner;
+
+		    free (error);
 		}
+		else
+		{
+		    dmxScreen->selectionOwner = reply->owner;
+		}
+	    }
+	    else
+	    {
+		dmxScreen->selectionOwner = dmxScreen->rootWin;
+	    }
+	}
+	else
+	{
+	    xcb_set_selection_owner (dmxScreen->connection,
+				     dmxScreen->rootWin,
+				     dmxScreen->beSelectionAtom,
+				     0);
+	}
+
+	free (reply);
+    }
+}
+
+static Bool
+dmxScreenEventCheckSelection (ScreenPtr           pScreen,
+			      xcb_generic_event_t *event)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    switch (event->response_type & ~0x80) {
+    case XCB_DESTROY_NOTIFY: {
+	xcb_destroy_notify_event_t *xdestroy =
+	    (xcb_destroy_notify_event_t *) event;
+
+	if (dmxSelectionDestroyNotify (pScreen, xdestroy->window))
+	    return TRUE;
+
+	if (xdestroy->window != dmxScreen->selectionOwner)
+	    return FALSE;
+
+	if (dmxScreen->selectionOwner == dmxScreen->rootWin)
+	    return FALSE;
+
+	dmxScreenGetSelectionOwner (pScreen);
+    } break;
+    case XCB_PROPERTY_NOTIFY: {
+	xcb_property_notify_event_t *xproperty =
+	    (xcb_property_notify_event_t *) event;
+
+	if (!dmxSelectionPropertyNotify (pScreen,
+					 xproperty->window,
+					 xproperty->state,
+					 xproperty->atom,
+					 xproperty->time))
+	    return FALSE;
+    } break;
+    case XCB_SELECTION_CLEAR: {
+	xcb_selection_clear_event_t *xclear =
+	    (xcb_selection_clear_event_t *) event;
+
+	if (xclear->selection == dmxScreen->beSelectionAtom)
+	{
+	    dmxScreenGetSelectionOwner (pScreen);
+	}
+	else
+	{
+	    dmxSelectionClear (pScreen,
+			       xclear->owner,
+			       xclear->selection);
+	}
+    } break;
+    case XCB_SELECTION_NOTIFY: {
+	xcb_selection_notify_event_t *xnotify =
+	    (xcb_selection_notify_event_t *) event;
+
+	dmxSelectionNotify (pScreen,
+			    xnotify->requestor,
+			    xnotify->selection,
+			    xnotify->target,
+			    xnotify->property,
+			    xnotify->time);
+    } break;
+    case XCB_SELECTION_REQUEST: {
+	xcb_selection_request_event_t *xrequest =
+	    (xcb_selection_request_event_t *) event;
+
+	dmxSelectionRequest (pScreen,
+			     xrequest->owner,
+			     xrequest->requestor,
+			     xrequest->selection,
+			     xrequest->target,
+			     xrequest->property,
+			     xrequest->time);
+    } break;
+    default:
+	return FALSE;
+    }
+
+    return TRUE;
+}
+
+static void
+dmxDiscardIgnore (DMXScreenInfo *dmxScreen,
+		  unsigned long sequence)
+{
+    while (dmxScreen->ignore.head)
+    {
+	if ((long) (sequence - dmxScreen->ignore.head->sequence) > 0)
+	{
+	    DMXSequence *next = dmxScreen->ignore.head->next;
+
+	    free (dmxScreen->ignore.head);
+
+	    dmxScreen->ignore.head = next;
+	    if (!dmxScreen->ignore.head)
+		dmxScreen->ignore.tail = &dmxScreen->ignore.head;
+	}
+	else
+	    break;
+    }
+}
+
+static Bool
+dmxShouldIgnore (DMXScreenInfo *dmxScreen,
+		 unsigned long sequence)
+{
+    dmxDiscardIgnore (dmxScreen, sequence);
+
+    if (!dmxScreen->ignore.head)
+	return FALSE;
+
+    return dmxScreen->ignore.head->sequence == sequence;
+}
+
+static Bool
+dmxScreenEventCheckExpose (ScreenPtr           pScreen,
+			   xcb_generic_event_t *event)
+{
+    DMXScreenInfo      *dmxScreen = &dmxScreens[pScreen->myNum];
+    xcb_expose_event_t *xexpose = (xcb_expose_event_t *) event;
+    WindowPtr          pChild0, pChildN;
+
+    if ((event->response_type & ~0x80) != XCB_EXPOSE)
+	return FALSE;
+
+    if (dmxShouldIgnore (dmxScreen, xexpose->sequence))
+	return TRUE;
+
+    pChild0 = WindowTable[0];
+    pChildN = WindowTable[pScreen->myNum];
+
+    for (;;)
+    {
+	dmxWinPrivPtr pWinPriv = DMX_GET_WINDOW_PRIV (pChildN);
+
+	if (pWinPriv->window == xexpose->window)
+	    break;
+
+	if (pChild0->firstChild)
+	{
+	    assert (pChildN->firstChild);
+	    pChild0 = pChild0->firstChild;
+	    pChildN = pChildN->firstChild;
+	    continue;
+	}
+
+	while (!pChild0->nextSib && (pChild0 != WindowTable[0]))
+	{
+	    assert (!pChildN->nextSib &&
+		    (pChildN != WindowTable[pScreen->myNum]));
+	    pChild0 = pChild0->parent;
+	    pChildN = pChildN->parent;
+	}
+
+	if (pChild0 == WindowTable[0])
+	{
+	    assert (pChildN == WindowTable[pScreen->myNum]);
+	    break;
+	}
+
+	pChild0 = pChild0->nextSib;
+	pChildN = pChildN->nextSib;
+    }
+
+    if (pChild0)
+    {
+	RegionRec region;
+	BoxRec    box;
+
+	box.x1 = pChild0->drawable.x + xexpose->x;
+	box.y1 = pChild0->drawable.y + xexpose->y;
+	box.x2 = box.x1 + xexpose->width;
+	box.y2 = box.y1 + xexpose->height;
+
+	REGION_INIT (screenInfo.screens[0], &region, &box, 1);
+	(*pScreen->WindowExposures) (pChild0, &region, NullRegion);
+	REGION_UNINIT (screenInfo.screens[0], &region);
+    }
+
+    return TRUE;
+}
+
+static Bool
+dmxScreenEventCheckOutputWindow (ScreenPtr	     pScreen,
+				 xcb_generic_event_t *event)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    switch (event->response_type & ~0x80) {
+    case XCB_DESTROY_NOTIFY: {
+	xcb_destroy_notify_event_t *xdestroy =
+	    (xcb_destroy_notify_event_t *) event;
+	
+	if (xdestroy->window != dmxScreen->scrnWin)
+	    return FALSE;
+
+	/* output window has been destroyed, detach screen when we reach
+	   the block handler */
+	dmxScreen->scrnWin = None;
+	return TRUE;
+    } break;
+    case XCB_MAP_NOTIFY: {
+	xcb_map_notify_event_t *xmap = (xcb_map_notify_event_t *) event;
+
+	if (xmap->window == dmxScreen->scrnWin)
+	    return TRUE;
+    } break;
+    default:
+	break;
+    }
+
+    return FALSE;
+}
+
+static Bool
+dmxScreenEventCheckManageRoot (ScreenPtr	   pScreen,
+			       xcb_generic_event_t *event)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+    WindowPtr     pChild = WindowTable[pScreen->myNum];
+    Window        xWindow;
+
+#ifdef PANORAMIX
+    PanoramiXRes  *win = NULL;
+    WindowPtr     pWin;
+#endif
+
+    xcb_circulate_request_event_t *xcirculaterequest =
+	(xcb_circulate_request_event_t *) event;
+    xcb_configure_request_event_t *xconfigurerequest =
+	(xcb_configure_request_event_t *) event;
+    xcb_map_request_event_t *xmaprequest =
+	(xcb_map_request_event_t *) event;
+    xcb_client_message_event_t *xclient =
+	(xcb_client_message_event_t *) event;
+    xcb_map_notify_event_t *xmap =
+	(xcb_map_notify_event_t *) event;
+
+    switch (event->response_type & ~0x80) {
+    case XCB_CIRCULATE_REQUEST:
+	xWindow = xcirculaterequest->window;
+	break;
+    case XCB_CONFIGURE_REQUEST:
+	xWindow = xconfigurerequest->window;
+	break;
+    case XCB_MAP_REQUEST:
+	xWindow = xmaprequest->window;
+	break;
+    case XCB_CLIENT_MESSAGE:
+	xWindow = xclient->window;
+	break;
+    case XCB_MAP_NOTIFY:
+	if (xmap->window == dmxScreen->rootWin)
+	{
+	    dmxScreenGetSelectionOwner (pScreen);
+	    return TRUE;
+	}
+
+	/* fall-through */
+    default:
+	return FALSE;
+    }
+
+    for (;;)
+    {
+	dmxWinPrivPtr pWinPriv = DMX_GET_WINDOW_PRIV (pChild);
+
+	if (pWinPriv->window == xWindow)
+	{
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+		win = PanoramiXFindIDByScrnum (XRT_WINDOW,
+					       pChild->drawable.id,
+					       pScreen->myNum);
+#endif
+
+	    break;
+	}
+
+	if (pChild->firstChild)
+	{
+	    pChild = pChild->firstChild;
+	    continue;
+	}
+
+	while (!pChild->nextSib &&
+	       (pChild != WindowTable[pScreen->myNum]))
+	    pChild = pChild->parent;
+
+	if (pChild == WindowTable[pScreen->myNum])
+	    break;
+
+	pChild = pChild->nextSib;
+    }
+
+    if (pChild
+
+#ifdef PANORAMIX
+	&& win
+#endif
+
+	)
+    {
+	XID    vlist[8];
+	Atom   type;
+	int    mask, i = 0;
+	int    status = Success;
+	xEvent x;
+
+	switch (event->response_type & ~0x80) {
+	case XCB_CIRCULATE_REQUEST:
+	    vlist[0] = None;
+
+	    if (xcirculaterequest->place == XCB_PLACE_ON_TOP)
+		vlist[1] = Above;
+	    else
+		vlist[1] = Below;
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		int j;
+
+		FOR_NSCREENS_FORWARD(j) {
+		    if (dixLookupWindow (&pWin,
+					 win->info[j].id,
+					 serverClient,
+					 DixReadAccess) == Success)
+			status |= ConfigureWindow (pWin,
+						   CWSibling |
+						   CWStackMode,
+						   vlist,
+						   serverClient);
+		}
+	    }
+	    else
+#endif
+		status = ConfigureWindow (pChild,
+					  CWSibling | CWStackMode,
+					  vlist,
+					  serverClient);
+	    break;
+	case XCB_CONFIGURE_REQUEST:
+	    mask = xconfigurerequest->value_mask;
+
+	    if (mask & (XCB_CONFIG_WINDOW_X | XCB_CONFIG_WINDOW_Y))
+	    {
+		vlist[i++] = xconfigurerequest->x;
+		vlist[i++] = xconfigurerequest->y;
+	    }
+
+	    if (mask & (XCB_CONFIG_WINDOW_WIDTH | XCB_CONFIG_WINDOW_HEIGHT))
+	    {
+		vlist[i++] = xconfigurerequest->width;
+		vlist[i++] = xconfigurerequest->height;
+	    }
+
+	    if (mask & XCB_CONFIG_WINDOW_BORDER_WIDTH)
+		vlist[i++] = xconfigurerequest->border_width;
+
+	    if (mask & XCB_CONFIG_WINDOW_SIBLING)
+	    {
+		/* ignore stacking requests with sibling */
+		if (xconfigurerequest->sibling == None)
+		    vlist[i++] = None;
+		else
+		    mask &= ~(XCB_CONFIG_WINDOW_SIBLING |
+			      XCB_CONFIG_WINDOW_STACK_MODE);
+	    }
+
+	    if (mask & XCB_CONFIG_WINDOW_STACK_MODE)
+		vlist[i++] = xconfigurerequest->stack_mode;
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		int j;
+
+		FOR_NSCREENS_FORWARD(j) {
+		    if (dixLookupWindow (&pWin,
+					 win->info[j].id,
+					 serverClient,
+					 DixReadAccess) == Success)
+			status |= ConfigureWindow (pWin,
+						   mask,
+						   vlist,
+						   serverClient);
+		}
+	    }
+	    else
+#endif
+
+		status = ConfigureWindow (pChild,
+					  mask,
+					  vlist,
+					  serverClient);
+	    break;
+	case XCB_MAP_REQUEST:
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		int j;
+
+		FOR_NSCREENS_FORWARD(j) {
+		    if (dixLookupWindow (&pWin,
+					 win->info[j].id,
+					 serverClient,
+					 DixReadAccess) == Success)
+			status |= MapWindow (pWin, serverClient);
+		}
+	    }
+	    else
+#endif
+
+		status = MapWindow (pChild, serverClient);
+	    break;
+	case XCB_CLIENT_MESSAGE:
+	    x.u.u.type               = ClientMessage | 0x80;
+	    x.u.u.detail             = xclient->format;
+	    x.u.clientMessage.window = pChild->drawable.id;
+
+	    type = dmxAtom (dmxScreen, xclient->type);
+
+	    switch (xclient->format) {
+	    case 8:
+		x.u.clientMessage.u.b.type = type;
+
+		for (i = 0; i < 20; i++)
+		    x.u.clientMessage.u.b.bytes[i] = xclient->data.data8[i];
+		break;
+	    case 16:
+		x.u.clientMessage.u.s.type = type;
+
+		x.u.clientMessage.u.s.shorts0 = xclient->data.data16[0];
+		x.u.clientMessage.u.s.shorts1 = xclient->data.data16[1];
+		x.u.clientMessage.u.s.shorts2 = xclient->data.data16[2];
+		x.u.clientMessage.u.s.shorts3 = xclient->data.data16[3];
+		x.u.clientMessage.u.s.shorts4 = xclient->data.data16[4];
+		x.u.clientMessage.u.s.shorts5 = xclient->data.data16[5];
+		x.u.clientMessage.u.s.shorts6 = xclient->data.data16[6];
+		x.u.clientMessage.u.s.shorts7 = xclient->data.data16[7];
+		x.u.clientMessage.u.s.shorts8 = xclient->data.data16[8];
+		x.u.clientMessage.u.s.shorts9 = xclient->data.data16[9];
+		break;
+	    case 32:
+		x.u.clientMessage.u.l.type = type;
+
+		x.u.clientMessage.u.l.longs0 = xclient->data.data32[0];
+		x.u.clientMessage.u.l.longs1 = xclient->data.data32[1];
+		x.u.clientMessage.u.l.longs2 = xclient->data.data32[2];
+		x.u.clientMessage.u.l.longs3 = xclient->data.data32[3];
+		x.u.clientMessage.u.l.longs4 = xclient->data.data32[4];
+		break;
+	    }
+
+	    /* client messages are always forwarded to the root
+	       window as there's no way for us to know which
+	       windows they were originally intended for */
+	    pWin = WindowTable[pScreen->myNum];
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		x.u.clientMessage.window = win->info[0].id;
+		pWin = WindowTable[0];
+	    }
+#endif
+
+	    DeliverEventsToWindow (PickPointer (serverClient),
+				   pWin,
+				   &x,
+				   1,
+				   SubstructureRedirectMask |
+				   SubstructureNotifyMask,
+				   NullGrab, 0);
+	    break;
+	}
+
+	if (status != Success)
+	    dmxLog (dmxWarning,
+		    "dmxScreenManage: failed to handle "
+		    "request type %d\n",
+		    event->response_type & ~0x80);
+    }
+    else
+    {
+	XWindowChanges xwc;
+
+	switch (event->response_type & ~0x80) {
+	case XCB_CIRCULATE_REQUEST:
+	    XLIB_PROLOGUE (dmxScreen);
+	    if (xcirculaterequest->place == XCB_PLACE_ON_TOP)
+		XRaiseWindow (dmxScreen->beDisplay,
+			      xcirculaterequest->window);
+	    else
+		XLowerWindow (dmxScreen->beDisplay,
+			      xcirculaterequest->window);
+	    XLIB_EPILOGUE (dmxScreen);
+	    break;
+	case XCB_CONFIGURE_REQUEST:
+	    xwc.x	     = xconfigurerequest->x;
+	    xwc.y	     = xconfigurerequest->y;
+	    xwc.width	     = xconfigurerequest->width;
+	    xwc.height	     = xconfigurerequest->height;
+	    xwc.border_width = xconfigurerequest->border_width;
+	    xwc.sibling      = xconfigurerequest->sibling;
+	    xwc.stack_mode   = xconfigurerequest->stack_mode;
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    XConfigureWindow (dmxScreen->beDisplay,
+			      xconfigurerequest->window,
+			      xconfigurerequest->value_mask,
+			      &xwc);
+	    XLIB_EPILOGUE (dmxScreen);
+	    break;
+	case XCB_MAP_REQUEST:
+	    XLIB_PROLOGUE (dmxScreen);
+	    XMapWindow (dmxScreen->beDisplay, xmaprequest->window);
+	    XLIB_EPILOGUE (dmxScreen);
+	    break;
+	case XCB_CLIENT_MESSAGE:
+	    break;
+	}
+    }
+
+    return TRUE;
+}
+
+void
+dmxBEDispatch (ScreenPtr pScreen)
+{
+    DMXScreenInfo       *dmxScreen = &dmxScreens[pScreen->myNum];
+    xcb_generic_event_t *event;
+    xcb_generic_error_t *error;
+    void                *reply;
+
+    assert (dmxScreen->inDispatch == FALSE);
+    dmxScreen->inDispatch = TRUE;
+
+    while ((event = xcb_poll_for_event (dmxScreen->connection)))
+    {
+	if (!dmxScreenEventCheckInput (pScreen, event)        &&
+	    !dmxScreenEventCheckSelection (pScreen, event)    &&
+	    !dmxScreenEventCheckDnD (pScreen, event)          &&
+	    !dmxScreenEventCheckOutputWindow (pScreen, event) &&
+	    !dmxScreenEventCheckManageRoot (pScreen, event)   &&
+
+#ifdef MITSHM
+	    !dmxScreenEventCheckShm (pScreen, event)          &&
+#endif
+
+#ifdef RANDR
+	    !dmxScreenEventCheckRR (pScreen, event)           &&
+#endif
+
+	    !dmxScreenEventCheckExpose (pScreen, event))
+	{
+	    if (event->response_type == 0)
+	    {
+		xcb_generic_error_t *error = (xcb_generic_error_t *) event;
+
+		dmxLogOutput (dmxScreen, "unhandled error type %d\n",
+			      error->error_code);
+	    }
+	    else
+	    {
+		dmxLogOutput (dmxScreen, "unhandled event type %d\n",
+			      event->response_type);
+	    }
+	}
+
+	free (event);
+    }
+
+    while (dmxScreen->request.head &&
+	   xcb_poll_for_reply (dmxScreen->connection,
+			       dmxScreen->request.head->sequence,
+			       (void **) &reply,
+			       &error))
+    {
+	DMXRequest *head = (DMXRequest *) dmxScreen->request.head;
+
+	dmxScreen->request.head = head->base.next;
+	if (!dmxScreen->request.head)
+	    dmxScreen->request.tail = &dmxScreen->request.head;
+
+	(*head->reply) (pScreen,
+			head->base.sequence,
+			reply,
+			error,
+			head->data);
+
+        if (reply)
+	    free (reply);
+        if (error)
+            free (error);
+
+	free (head);
+    }
+
+    if (!dmxScreen->scrnWin ||
+	xcb_connection_has_error (dmxScreen->connection))
+    {
+	static xcb_generic_error_t detached_error = { 0, DMX_DETACHED };
+
+	while (dmxScreen->request.head)
+	{
+	    DMXRequest *head = (DMXRequest *) dmxScreen->request.head;
+
+	    dmxScreen->request.head = head->base.next;
+	    if (!dmxScreen->request.head)
+		dmxScreen->request.tail = &dmxScreen->request.head;
+
+	    (*head->reply) (pScreen,
+			    head->base.sequence,
+			    NULL,
+			    &detached_error,
+			    head->data);
+
+	    free (head);
+	}
+
+	dmxScreen->broken = TRUE;
+    }
+
+    dmxScreen->inDispatch = FALSE;
+}
+
+static void
+dmxScreenCheckForIOError (ScreenPtr pScreen)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    if (!dmxScreen->scrnWin ||
+	xcb_connection_has_error (dmxScreen->connection))
+    {
+	int i;
+
+	if (dmxScreen->scrnWin)
+	{
+	    dmxLogOutput (dmxScreen, "Detected broken connection\n");
+	    dmxScreen->alive = FALSE;
+	}
+
+	if (!dmxScreen->broken)
+	    dmxBEDispatch (pScreen);
+
+	dmxDetachScreen (pScreen->myNum);
+
+	for (i = 0; i < dmxNumScreens; i++)
+	    if (i != pScreen->myNum && dmxScreens[i].beDisplay)
+		break;
+
+	if (i == dmxNumScreens)
+	    dmxLog (dmxFatal, "No back-end server connection, "
+		    "giving up\n");
+    }
+}
+
+static void
+dmxScreenBlockHandler (pointer   blockData,
+		       OSTimePtr pTimeout,
+		       pointer   pReadMask)
+{
+    ScreenPtr     pScreen = (ScreenPtr) blockData;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    if (dmxScreen->alive)
+    {
+	xcb_flush (dmxScreen->connection);
+	dmxScreenCheckForIOError (pScreen);
+    }
+}
+
+static void
+dmxScreenWakeupHandler (pointer blockData,
+			int     result,
+			pointer pReadMask)
+{
+    ScreenPtr     pScreen = (ScreenPtr) blockData;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    if (dmxScreen->alive)
+	dmxBEDispatch (pScreen);
+}
+
+static void
+dmxHandleExposures (WindowPtr pWin)
+{
+    WindowPtr pChild;
+    ValidatePtr val;
+    ScreenPtr pScreen;
+    WindowExposuresProcPtr WindowExposures;
+
+    pScreen = pWin->drawable.pScreen;
+
+    pChild = pWin;
+    WindowExposures = pChild->drawable.pScreen->WindowExposures;
+    while (1)
+    {
+	if ( (val = pChild->valdata) )
+	{
+	    REGION_UNINIT(pScreen, &val->after.borderExposed);
+	    (*WindowExposures)(pChild, &val->after.exposed, NullRegion);
+	    REGION_UNINIT(pScreen, &val->after.exposed);
+	    xfree(val);
+	    pChild->valdata = (ValidatePtr)NULL;
+	    if (pChild->firstChild)
+	    {
+		pChild = pChild->firstChild;
+		continue;
+	    }
+	}
+	while (!pChild->nextSib && (pChild != pWin))
+	    pChild = pChild->parent;
+	if (pChild == pWin)
+	    break;
+	pChild = pChild->nextSib;
     }
 }
 
@@ -216,15 +1020,27 @@ Bool dmxScreenInit(int idx, ScreenPtr pS
 	dmxGeneration = serverGeneration;
     }
 
-    if (dmxShadowFB) {
-	dmxScreen->shadow = shadowAlloc(dmxScreen->scrnWidth,
-					dmxScreen->scrnHeight,
-					dmxScreen->beBPP);
-    } else {
-	if (!dmxInitGC(pScreen)) return FALSE;
-	if (!dmxInitWindow(pScreen)) return FALSE;
-	if (!dmxInitPixmap(pScreen)) return FALSE;
-    }
+    dmxInputInit (&dmxScreen->input);
+
+    dmxScreen->ignore.head = NULL;
+    dmxScreen->ignore.tail = &dmxScreen->ignore.head;
+
+    dmxScreen->request.head = NULL;
+    dmxScreen->request.tail = &dmxScreen->request.head;
+
+    dmxScreen->scrnEventMask = 0;
+
+    dmxScreen->rootEventMask = ExposureMask | StructureNotifyMask |
+	SubstructureRedirectMask;
+
+    dmxScreen->multipleAtom = MakeAtom ("MULTIPLE", strlen ("MULTIPLE"), TRUE);
+    dmxScreen->atomPairAtom = MakeAtom ("ATOM_PAIR", strlen ("ATOM_PAIR"), TRUE);
+    dmxScreen->incrAtom = MakeAtom ("INCR", strlen ("INCR"), TRUE);
+
+    if (!dmxInitGC(pScreen)) return FALSE;
+    if (!dmxInitWindow(pScreen)) return FALSE;
+    if (!dmxInitPixmap(pScreen)) return FALSE;
+    if (!dmxInitCursor(pScreen)) return FALSE;
 
     /*
      * Initalise the visual types.  miSetVisualTypesAndMasks() requires
